<link rel="import" href="../../polymer/polymer-element.html" />

<link rel="import" href="tabla-element.html" />
<link rel="import" href="buscador-element.html" />
<link rel="stylesheet" href="../bulma.min.css" />

<dom-module id="empleados-element">
    <template>
        <buscador-element></buscador-element>
        <tabla-element></tabla-element>
    </template>

    <script>
        /**
         * `empleados-element`
         * Ejemplo con una API dummy de empleados
         *
         * @customElement
         * @polymer
         * @demo demo/index.html
         */
        class EmpleadosElement extends Polymer.Element {
            constructor() {
                super();
                this.addEventListener("filtrados", ({ detail }) => {
                    this.shadowRoot.querySelector("tabla-element").mostrarEmpleados(detail);
                });
            }
            static get is() {
                return "empleados-element";
            }
            static get properties() {
                return {
                    prop1: {
                        type: String,
                        value: "empleados-element",
                    },
                };
            }
            async ready() {
                super.ready();
                const empleados = await this.obtenerDatos();
                this.shadowRoot.querySelector("buscador-element").empleados = empleados;
                this.shadowRoot.querySelector("tabla-element").mostrarEmpleados(empleados);
            }

            async obtenerDatos() {
                const datos = await fetch("http://dummy.restapiexample.com/api/v1/employees");
                const { data } = await datos.json();
                return data;
            }
        }

        window.customElements.define(EmpleadosElement.is, EmpleadosElement);
    </script>
</dom-module>
